is_binary_data uses wrong heuristic to decide if a string is binary

2010-12-19 14:00 - Jérémy Lal

Status: Closed Start date: 2010-12-19

Priority: Low Due date:  

Assignee:  % Done: 0%

Category: SCM Estimated time: 0.00 hour

Target version:    

Resolution: Duplicate Affected version:  

Description

The is_binary_data method, used in repositories_controller.rb#124, is :

def is_binary_data?

  ( self.count( "^ -~", "^\r\n" ) / self.size > 0.3 || self.count( "\x00" ) > 0 ) unless empty?

end

 Applied to the attached file :

str=''

File.open("test_color.sh", "r") { |f|

    str = f.read

}

(str.count("^ -~", "^\r\n") +0.0)/ str.length

=> 0.311345646437995

Which clearly is not < 0.3, so that file is downloaded instead of being displayed,

when one want to view it.

Related issues:

Is duplicate of Redmine - Defect #6256: Redmine considers non ASCII and UTF-1... Closed 2010-08-31

History

#1 - 2010-12-19 14:36 - Jérémy Lal

Ideally it should get the binary attribute from the SCM, but i don't know if all SCM have interface to get that information.

#2 - 2010-12-19 17:32 - Jean-Philippe Lang

- Category set to SCM

- Priority changed from Normal to Low

#3 - 2010-12-20 09:46 - ylgod jo

- Assignee set to Jim Mulholland

- % Done changed from 0 to 80

#4 - 2010-12-20 18:50 - Jean-Philippe Lang

- Assignee deleted (Jim Mulholland)

- % Done changed from 80 to 0

#5 - 2010-12-20 19:56 - Jean-Philippe Lang

- Status changed from New to Closed

- Resolution set to Duplicate

Same as #6256.

2025-08-23 1/2

https://www.redmine.org/issues/6256


Files

test_color.sh 758 Bytes 2010-12-19 Jérémy Lal
